#include <amxmodx>

const REASON_LENGTH = 64;

native ucc_is_client_gaged(index, &expired_time, gag_reason[REASON_LENGTH]);
native ucc_set_client_gag(index, admin_index, block_time, gag_reason[REASON_LENGTH]);

public plugin_init()
{
	register_concmd("ucc_show_players", "concmd_ShowPlayers");
}

public concmd_ShowPlayers(id)
{
	new players[32], pnum;
	get_players(players, pnum);
	
	for(new i, expired, reason[REASON_LENGTH]; i < pnum; ++i)
	{
		if(ucc_is_client_gaged(players[i], expired, reason))
		{
			console_print(id, "[*] Player <%d> is MUTED. Expired time <%d>. Reason '%s'", players[i], expired, reason);
		}
		else
		{
			console_print(id, "[*] Player <%d> is notMUTED.", players[i]);
		}
	}
	
	ucc_set_client_gag(players[random(pnum)], id, 3, "test");
}	